var GSBar =
{
  visible: true
};

GSBar.prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
GSBar.request = new XMLHttpRequest();
GSBar.collectionsmap = new Array();

GSBar.hideshowbar = function()
{
  if(document.getElementById("gsbar-menuitem").getAttribute('checked'))
  {
    document.getElementById("gsbar").setAttribute('hidden', false);
  }
  else
  {
    document.getElementById("gsbar").setAttribute('hidden', true);
  }
}

GSBar.clearsearchbox = function()
{
  var searchbox = document.getElementById("search-terms");
  searchbox.value = "";
  searchbox.setAttribute('onfocus', null);
}

GSBar.search = function() 
{
  if (document.getElementById("collection-list").selectedItem.label == "-- Please select a collection --")
  {
    alert("Please select a collection");
    die;
  }

  //Get the search terms
  var terms = document.getElementById("search-terms").value;
  terms = terms.replace(/ /g, "+");
  terms = terms.replace(/&/g, "%26");
  terms = terms.replace(/\|/g, "%7C");
  terms = terms.replace(/!/g, "%21");

  var url_to_open = "http://www.nzdl.org/cgi-bin/library?";	//1. The initial url

  url_to_open = url_to_open + "a=q";  				//2. Add "a=q" to show we are doing a query
  url_to_open = url_to_open + "&q=";				//3. Add "q=" to specify a query
  url_to_open = url_to_open + terms;				//4. Add the query terms to the url
  url_to_open = url_to_open + "&c=";				//5. Add "c=" to specify a collection

  //6. Find out which collection is specified and add it to the url
  url_to_open = url_to_open + GSBar.collectionsmap[document.getElementById("collection-list").selectedItem.label];

  //Load preferences
  var casefoldingpref = GSBar.prefManager.getBoolPref("extensions.greenstonesearchbar.searchpref.casefolding");
  var stemmingpref = GSBar.prefManager.getBoolPref("extensions.greenstonesearchbar.searchpref.stemming");
  var querytypepref = GSBar.prefManager.getCharPref("extensions.greenstonesearchbar.searchpref.querytype");
  var numofresultspref = GSBar.prefManager.getCharPref("extensions.greenstonesearchbar.searchpref.numofresults");
  var numperpagepref = GSBar.prefManager.getCharPref("extensions.greenstonesearchbar.searchpref.numperpage");

  //Add the options
  url_to_open = url_to_open + "&k=";				//7. Add "k=" to specify the value of casefolding
  url_to_open = url_to_open + ((casefoldingpref) ? "1" : "0");	//8. Add the value of casefolding
  url_to_open = url_to_open + "&s=";				//9. Add "s=" to specify the value of stemming
  url_to_open = url_to_open + ((stemmingpref) ? "1" : "0");	//10. Add the value of stemming

  //11. Check what type of query it is
  if (querytypepref == "all")
  {
    url_to_open = url_to_open + "&b=0&t=0";				
  }
  else if (querytypepref == "some")
  {
    url_to_open = url_to_open + "&b=0&t=1";				
  }
  else if (querytypepref == "ranked")
  {
    url_to_open = url_to_open + "&b=1&t=0";				
  }
  else (querytypepref == "boolean")
  {
    url_to_open = url_to_open + "&b=1&t=1";				
  }

  url_to_open = url_to_open + "&m=";				//12. Add "m=" to specify the amount of documents to find
  url_to_open = url_to_open + numofresultspref;			//13. Add the the number of results to find
  url_to_open = url_to_open + "&o=";				//14. Add "o=" to specify the amount of documents to display per page
  url_to_open = url_to_open + numperpagepref;			//15. Add the the number of results to display per page

  //Open the window with this url
  var mainwindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
  .getInterface(Components.interfaces.nsIWebNavigation)
  .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
  .rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
  .getInterface(Components.interfaces.nsIDOMWindow);
      
   mainwindow.open(url_to_open);
}

GSBar.enter = function(e)
{
  if(e == 13)
  {
    GSBar.search();
  }
  return true;
}

GSBar.home = function()
{
  //Open the window with this url
  var mainwindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
  .getInterface(Components.interfaces.nsIWebNavigation)
  .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
  .rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
  .getInterface(Components.interfaces.nsIDOMWindow);
      
   mainwindow.open("http://www.nzdl.org");
}

GSBar.logorollover = function()
{
  document.getElementById("gslogo").setAttribute('src', "chrome://greenstonesearchbar/skin/NewGreenstoneLogoOver.gif");
}

GSBar.logorollout = function()
{
  document.getElementById("gslogo").setAttribute('src', "chrome://greenstonesearchbar/skin/NewGreenstoneLogo.gif");
}

GSBar.getcollections = function(e)
{
  GSBar.request.onreadystatechange = GSBar.nzdlrequest;

  GSBar.request.open("GET", "http://www.nzdl.org", true);
  GSBar.request.send("");
}

GSBar.nzdlrequest = function()
{
  if (GSBar.request.readyState == 4)
  {
    var collectionlist = document.getElementById("collection-list-popup");
    var collectionlongname;
    var collectionshortname;
    var newmenuitem;
    var page = GSBar.request.responseText;

    while(page.indexOf("&c=") != -1)
    {
      collectionshortname = "";
      collectionlongname = "";
      page = page.slice(page.indexOf("&c=")+3);
      if(page.indexOf("&") < page.indexOf("\""))
      {
        collectionshortname = page.substr(0, page.indexOf("&"));
      }
      else
      {
        collectionshortname = page.substr(0, page.indexOf("\""));
      }
      //alert("|"+ collectionshortname +"|");
      page = page.slice(page.indexOf("alt=")+5);
      collectionlongname = page.substr(0, page.indexOf("\""));
      //alert("|"+ collectionlongname +"|");

      if(collectionshortname != "" && collectionlongname != "")
      {
        GSBar.collectionsmap[collectionlongname] = collectionshortname;
        newmenuitem = document.createElement("menuitem");
        newmenuitem.setAttribute('label', collectionlongname);
        newmenuitem.setAttribute('style', "font-size: 90%");
        collectionlist.appendChild(newmenuitem);
      }
    }
  }
}

window.addEventListener("load", function(e) {GSBar.getcollections(e);}, false);